from functools import wraps
from event_testing.objective_tuning import Objective
from sims.sim_info_manager import SimInfoManager
from sims4.tuning.instances import HashedTunedInstanceMetaclass
import services
import sims4.log
import sims4.tuning.tunable

def inject(target_function, new_function):
    @wraps(target_function)
    def _inject(*args, **kwargs):
        return new_function(target_function, *args, **kwargs)
    return _inject

def inject_to(target_object, target_function_name):
    def _inject_to(new_function):
        target_function = getattr(target_object, target_function_name)
        setattr(target_object, target_function_name, inject(target_function, new_function))
        return new_function
    return _inject_to

class ActionTriggerMetaclass(HashedTunedInstanceMetaclass):
    pass
class ActionTrigger(Objective, metaclass=ActionTriggerMetaclass, manager=services.objective_manager()):
    @classmethod
    def activate_action_trigger(cls):
        services.get_event_manager().register_tests(cls, (cls.objective_test,))
    @classmethod
    def handle_event(cls, sim_info, event, resolver):
        if sim_info is None:
            return
        for loot_action in cls.completion_loot:
            loot_action.apply_to_resolver(resolver)
@inject_to(SimInfoManager, 'on_loading_screen_animation_finished')
def Skarrd_TraitsFondlingGropingAddon_activate_action_triggers(original, self, *args, **kwargs):
    for objective in services.objective_manager().types.values():
        if isinstance(objective, ActionTriggerMetaclass):
            objective.activate_action_trigger()

